VTK: vtkPolyData Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
vtkPolyData Class Reference

concrete dataset represents vertices, lines, polygons, and triangle strips More...

`#include <vtkPolyData.h>`

Inheritance diagram for vtkPolyData:
[legend]
Collaboration diagram for vtkPolyData:
[legend]

## Public Types
enum | { ERR_NO_SUCH_FIELD = -4 , ERR_INCORRECT_FIELD = -3 , ERR_NON_MANIFOLD_STAR = -2 , REGULAR_POINT = -1 , MINIMUM = 0 , SADDLE = 1 , MAXIMUM = 2 }
| Scalar field critical point classification (for manifold 2D meshes). More...
typedef vtkPointSet | Superclass
Public Types inherited from vtkPointSet
typedef vtkDataSet | Superclass
| Standard methods for type information and printing. More...
Public Types inherited from vtkDataSet
enum | FieldDataType { DATA_OBJECT_FIELD = 0 , POINT_DATA_FIELD = 1 , CELL_DATA_FIELD = 2 }
typedef vtkDataObject | Superclass
Public Types inherited from vtkDataObject
enum | FieldAssociations { FIELD_ASSOCIATION_POINTS , FIELD_ASSOCIATION_CELLS , FIELD_ASSOCIATION_NONE , FIELD_ASSOCIATION_POINTS_THEN_CELLS , FIELD_ASSOCIATION_VERTICES , FIELD_ASSOCIATION_EDGES , FIELD_ASSOCIATION_ROWS , NUMBER_OF_ASSOCIATIONS }
| Possible values for the FIELD_ASSOCIATION information entry. More...
enum | AttributeTypes { POINT , CELL , FIELD , POINT_THEN_CELL , VERTEX , EDGE , ROW , NUMBER_OF_ATTRIBUTE_TYPES }
| Possible attribute types. More...
enum | FieldOperations { FIELD_OPERATION_PRESERVED , FIELD_OPERATION_REINTERPOLATED , FIELD_OPERATION_MODIFIED , FIELD_OPERATION_REMOVED }
| Possible values for the FIELD_OPERATION information entry. More...
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for type information and printing. More...
vtkPolyData * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
int | GetDataObjectType () override
| Return what type of dataset this is. More...
void | CopyStructure (vtkDataSet *ds) override
| Copy the geometric and topological structure of an input poly data object. More...
void | CopyCells (vtkPolyData *pd, vtkIdList *idList, vtkIncrementalPointLocator *locator=nullptr)
| Copy cells listed in idList from pd, including points, point data, and cell data. More...
void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds) override
| Copy a cells point ids into list provided. More...
void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds) override
| Efficient method to obtain cells using a particular point. More...
void | ComputeCellsBounds ()
| Compute the (X, Y, Z) bounds of the data. More...
void | GetCellsBounds (double bounds[6])
| Get the cells bounds. More...
void | Squeeze () override
| Recover extra allocated memory when creating data whose initial size is unknown. More...
int | GetMaxCellSize () override
| Return the maximum cell size in this poly data. More...
vtkIdType | GetCellIdRelativeToCellArray (vtkIdType cellId)
| Maps the cell at position `cellId` inside the `vtkPolyData` to its location in the corresponding cell array. More...
void | SetVerts (vtkCellArray *v)
| Set the cell array defining vertices. More...
vtkCellArray * | GetVerts ()
| Get the cell array defining vertices. More...
void | SetLines (vtkCellArray *l)
| Set the cell array defining lines. More...
vtkCellArray * | GetLines ()
| Get the cell array defining lines. More...
void | SetPolys (vtkCellArray *p)
| Set the cell array defining polygons. More...
vtkCellArray * | GetPolys ()
| Get the cell array defining polygons. More...
void | SetStrips (vtkCellArray *s)
| Set the cell array defining triangle strips. More...
vtkCellArray * | GetStrips ()
| Get the cell array defining triangle strips. More...
bool | AllocateEstimate (vtkIdType numCells, vtkIdType maxCellSize)
| Preallocate memory for the internal cell arrays. More...
bool | AllocateEstimate (vtkIdType numVerts, vtkIdType maxVertSize, vtkIdType numLines, vtkIdType maxLineSize, vtkIdType numPolys, vtkIdType maxPolySize, vtkIdType numStrips, vtkIdType maxStripSize)
| Preallocate memory for the internal cell arrays. More...
bool | AllocateExact (vtkIdType numCells, vtkIdType connectivitySize)
| Preallocate memory for the internal cell arrays. More...
bool | AllocateExact (vtkIdType numVerts, vtkIdType vertConnSize, vtkIdType numLines, vtkIdType lineConnSize, vtkIdType numPolys, vtkIdType polyConnSize, vtkIdType numStrips, vtkIdType stripConnSize)
| Preallocate memory for the internal cell arrays. More...
bool | AllocateCopy (vtkPolyData *pd)
| Preallocate memory for the internal cell arrays such that they are the same size as those in pd. More...
bool | AllocateProportional (vtkPolyData *pd, double ratio)
| Preallocate memory for the internal cell arrays such that they are proportional to those in pd by a factor of ratio (for instance, ratio = 2 allocates twice as many cells). More...
void | Allocate (vtkIdType numCells=1000, int vtkNotUsed(extSize)=1000)
| Method allocates initial storage for vertex, line, polygon, and triangle strip arrays. More...
void | Allocate (vtkPolyData *inPolyData, vtkIdType numCells=1000, int vtkNotUsed(extSize)=1000)
| Similar to the method above, this method allocates initial storage for vertex, line, polygon, and triangle strip arrays. More...
vtkIdType | InsertNextCell (int type, int npts, const vtkIdType pts[])
| Insert a cell of type VTK_VERTEX, VTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE, VTK_QUAD, VTK_POLYGON, or VTK_TRIANGLE_STRIP. More...
vtkIdType | InsertNextCell (int type, vtkIdList *pts)
| Insert a cell of type VTK_VERTEX, VTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE, VTK_QUAD, VTK_POLYGON, or VTK_TRIANGLE_STRIP. More...
void | Reset ()
| Begin inserting data all over again. More...
void | BuildCells ()
| Create data structure that allows random access of cells. More...
bool | NeedToBuildCells ()
| Check if BuildCells is needed. More...
void | BuildLinks (int initialSize=0)
| Create upward links from points to cells that use each point. More...
void | DeleteCells ()
| Release data structure that allows random access of the cells. More...
void | DeleteLinks ()
| Release the upward links from point to cells that use each point. More...
void | GetCellEdgeNeighbors (vtkIdType cellId, vtkIdType p1, vtkIdType p2, vtkIdList *cellIds)
| Get the neighbors at an edge. More...
unsigned char | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts)
| Get a list of point ids that define a cell. More...
void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds) override
| Get a list of point ids that define a cell. More...
int | IsTriangle (int v1, int v2, int v3)
| Given three vertices, determine whether it's a triangle. More...
int | IsEdge (vtkIdType p1, vtkIdType p2)
| Determine whether two points form an edge. More...
int | IsPointUsedByCell (vtkIdType ptId, vtkIdType cellId)
| Determine whether a point is used by a particular cell. More...
void | ReverseCell (vtkIdType cellId)
| Reverse the order of point ids defining the cell. More...
void | RemoveDeletedCells ()
| The cells marked by calls to DeleteCell are stored in the Cell Array VTK_EMPTY_CELL, but they still exist in the cell arrays. More...
vtkIdType | InsertNextLinkedCell (int type, int npts, const vtkIdType pts[])
| Add a new cell to the cell data structure (after cell pointers have been built). More...
void | ReplaceLinkedCell (vtkIdType cellId, int npts, const vtkIdType pts[])
| Replace one cell with another in cell structure. More...
void | RemoveCellReference (vtkIdType cellId)
| Remove all references to cell in cell structure. More...
void | AddCellReference (vtkIdType cellId)
| Add references to cell in cell structure. More...
void | RemoveReferenceToCell (vtkIdType ptId, vtkIdType cellId)
| Remove a reference to a cell in a particular point's link list. More...
void | AddReferenceToCell (vtkIdType ptId, vtkIdType cellId)
| Add a reference to a cell in a particular point's link list. More...
void | ResizeCellList (vtkIdType ptId, int size)
| Resize the list of cells using a particular point. More...
void | Initialize () override
| Restore object to initial state. More...
virtual int | GetGhostLevel ()
| Get the ghost level. More...
unsigned long | GetActualMemorySize () override
| Return the actual size of the data in kibibytes (1024 bytes). More...
void | RemoveGhostCells ()
| This method will remove any cell that is marked as ghost (has the vtkDataSetAttributes::DUPLICATECELL or the vtkDataSetAttributes::HIDDENCELL bit set). More...
int | GetScalarFieldCriticalIndex (vtkIdType pointId, vtkDataArray *scalarField)
int | GetScalarFieldCriticalIndex (vtkIdType pointId, int fieldId)
int | GetScalarFieldCriticalIndex (vtkIdType pointId, const char *fieldName)
virtual vtkMTimeType | GetMeshMTime ()
| Return the mesh (geometry/topology) modification time. More...
vtkMTimeType | GetMTime () override
| Get MTime which also considers its cell array MTime. More...
unsigned char | GetCell (vtkIdType cellId, const vtkIdType *&pts)
| Get a pointer to the cell, ie [npts pid1 . More...
vtkIdType | GetNumberOfCells () override
| Standard vtkDataSet interface. More...
vtkCell * | GetCell (vtkIdType cellId) override
| Standard vtkDataSet interface. More...
void | GetCell (vtkIdType cellId, vtkGenericCell *cell) override
| Standard vtkDataSet interface. More...
int | GetCellType (vtkIdType cellId) override
| Standard vtkDataSet interface. More...
vtkIdType | GetCellSize (vtkIdType cellId) override
| Standard vtkDataSet interface. More...
void | GetCellBounds (vtkIdType cellId, double bounds[6]) override
| Standard vtkDataSet interface. More...
void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds) override
| Standard vtkDataSet interface. More...
virtual vtkCell * | GetCell (vtkIdType cellId)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
| Standard vtkDataSet interface. More...
virtual void | GetCell (vtkIdType cellId, vtkGenericCell *cell)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
vtkIdType | GetNumberOfVerts ()
| Return the number of primitives of a particular type held. More...
vtkIdType | GetNumberOfLines ()
| Return the number of primitives of a particular type held. More...
vtkIdType | GetNumberOfPolys ()
| Return the number of primitives of a particular type held. More...
vtkIdType | GetNumberOfStrips ()
| Return the number of primitives of a particular type held. More...
virtual void | SetLinks (vtkAbstractCellLinks *links)
| Set/Get the links that you created possibly without using BuildLinks. More...
| vtkGetSmartPointerMacro (Links, vtkAbstractCellLinks)
| Set/Get the links that you created possibly without using BuildLinks. More...
void | GetPointCells (vtkIdType ptId, vtkIdType &ncells, vtkIdType *&cells)
| Special (efficient) operations on poly data. More...
void | ReplaceCell (vtkIdType cellId, vtkIdList *ids)
| Replace the points defining cell "cellId" with a new set of points. More...
void | ReplaceCell (vtkIdType cellId, int npts, const vtkIdType pts[])
| Replace the points defining cell "cellId" with a new set of points. More...
void | ReplaceCellPoint (vtkIdType cellId, vtkIdType oldPtId, vtkIdType newPtId)
| Replace a point in the cell connectivity list with a different point. More...
void | ReplaceCellPoint (vtkIdType cellId, vtkIdType oldPtId, vtkIdType newPtId, vtkIdList *cellPointIds)
| Replace a point in the cell connectivity list with a different point. More...
void | DeletePoint (vtkIdType ptId)
| Mark a point/cell as deleted from this vtkPolyData. More...
void | DeleteCell (vtkIdType cellId)
| Mark a point/cell as deleted from this vtkPolyData. More...
vtkIdType | InsertNextLinkedPoint (int numLinks)
| Add a point to the cell data structure (after cell pointers have been built). More...
vtkIdType | InsertNextLinkedPoint (double x[3], int numLinks)
| Add a point to the cell data structure (after cell pointers have been built). More...
virtual int | GetPiece ()
| Get the piece and the number of pieces. More...
virtual int | GetNumberOfPieces ()
| Get the piece and the number of pieces. More...
void | ShallowCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
void | DeepCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
Public Member Functions inherited from vtkPointSet
double * | GetPoint (vtkIdType ptId) override
| See vtkDataSet for additional information. More...
vtkCellIterator * | NewCellIterator () override
| Return an iterator that traverses the cells in this data set. More...
void | BuildCellLocator ()
| Build the cell locator. More...
void | ComputeBounds () override
| Compute the (X, Y, Z) bounds of the data. More...
virtual void | SetEditable (bool)
| Specify whether this dataset is editable after creation. More...
virtual bool | GetEditable ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOn ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOff ()
| Specify whether this dataset is editable after creation. More...
vtkIdType | GetNumberOfPoints () override
| See vtkDataSet for additional information. More...
void | GetPoint (vtkIdType ptId, double x[3]) override
| See vtkDataSet for additional information. More...
vtkIdType | FindPoint (double x[3]) override
| See vtkDataSet for additional information. More...
vtkIdType | FindPoint (double x, double y, double z)
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)=0
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
void | BuildPointLocator ()
| Build the internal point locator . More...
void | BuildLocator ()
| Build the internal point locator . More...
virtual void | SetPointLocator (vtkAbstractPointLocator *)
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual vtkAbstractPointLocator * | GetPointLocator ()
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual void | SetCellLocator (vtkAbstractCellLocator *)
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual vtkAbstractCellLocator * | GetCellLocator ()
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual void | SetPoints (vtkPoints *)
| Specify point array to define point coordinates. More...
virtual vtkPoints * | GetPoints ()
| Specify point array to define point coordinates. More...
bool | UsesGarbageCollector () const override
| Overwritten to handle the data/locator loop. More...
vtkPointSet * | NewInstance () const
| Standard methods for type information and printing. More...
Public Member Functions inherited from vtkDataSet
vtkDataSet * | NewInstance () const
virtual void | CopyAttributes (vtkDataSet *ds)
| Copy the attributes associated with the specified dataset to this instance of vtkDataSet. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
void | SetCellOrderAndRationalWeights (vtkIdType cellId, vtkGenericCell *cell)
virtual void | GetCellTypes (vtkCellTypes *types)
| Get a list of types of cells in a dataset. More...
int | GetCellNumberOfFaces (vtkIdType cellId, unsigned char &cellType, vtkGenericCell *cell)
| Get the number of faces of a cell. More...
virtual vtkCell * | FindAndGetCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)
| Locate the cell that contains a point and return the cell. More...
vtkCellData * | GetCellData ()
| Return a pointer to this dataset's cell data. More...
vtkPointData * | GetPointData ()
| Return a pointer to this dataset's point data. More...
double * | GetBounds ()
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
void | GetBounds (double bounds[6])
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
double * | GetCenter ()
| Get the center of the bounding box. More...
void | GetCenter (double center[3])
| Get the center of the bounding box. More...
double | GetLength ()
| Return the length of the diagonal of the bounding box. More...
double | GetLength2 ()
| Return the squared length of the diagonal of the bounding box. More...
virtual void | GetScalarRange (double range[2])
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
double * | GetScalarRange ()
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
int | CheckAttributes ()
| This method checks to see if the cell and point attributes match the geometry. More...
vtkFieldData * | GetAttributesAsFieldData (int type) override
| Returns the attributes of the data object as a vtkFieldData. More...
vtkIdType | GetNumberOfElements (int type) override
| Get the number of elements for a specific attribute type (POINT, CELL, etc.). More...
bool | HasAnyGhostCells ()
| Returns 1 if there are any ghost cells 0 otherwise. More...
bool | HasAnyGhostPoints ()
| Returns 1 if there are any ghost points 0 otherwise. More...
virtual bool | HasAnyBlankCells ()
| Returns 1 if there are any blanking cells 0 otherwise. More...
virtual bool | HasAnyBlankPoints ()
| Returns 1 if there are any blanking points 0 otherwise. More...
vtkUnsignedCharArray * | GetPointGhostArray ()
| Gets the array that defines the ghost type of each point. More...
void | UpdatePointGhostArrayCache ()
| Updates the pointer to the point ghost array. More...
vtkUnsignedCharArray * | AllocatePointGhostArray ()
| Allocate ghost array for points. More...
vtkUnsignedCharArray * | GetCellGhostArray ()
| Get the array that defines the ghost type of each cell. More...
void | UpdateCellGhostArrayCache ()
| Updates the pointer to the cell ghost array. More...
vtkUnsignedCharArray * | AllocateCellGhostArray ()
| Allocate ghost array for cells. More...
vtkUnsignedCharArray * | GetGhostArray (int type) override
| Returns the ghost array for the given type (point or cell). More...
vtkIdType | FindPoint (double x, double y, double z)
| Locate the closest point to the global coordinate x. More...
virtual void | GenerateGhostArray (int zeroExt[6])
| Normally called by pipeline executives or algorithms only. More...
virtual void | GenerateGhostArray (int zeroExt[6], bool cellOnly)
| Normally called by pipeline executives or algorithms only. More...
Public Member Functions inherited from vtkDataObject
vtkDataObject * | NewInstance () const
void | ReleaseData ()
| Release data back to system to conserve memory resource. More...
vtkMTimeType | GetUpdateTime ()
| Used by Threaded ports to determine if they should initiate an asynchronous update (still in development). More...
virtual void | CopyInformationFromPipeline (vtkInformation *vtkNotUsed(info))
| Copy from the pipeline information to the data object's own information. More...
virtual void | CopyInformationToPipeline (vtkInformation *vtkNotUsed(info))
| Copy information from this data object to the pipeline information. More...
void | DataHasBeenGenerated ()
| This method is called by the source when it executes to generate data. More...
virtual void | PrepareForNewData ()
| make the output data ready for new data to be inserted. More...
virtual int | GetExtentType ()
| The ExtentType will be left as VTK_PIECES_EXTENT for data objects such as vtkPolyData and vtkUnstructuredGrid. More...
virtual void | Crop (const int *updateExtent)
| This method crops the data object (if necessary) so that the extent matches the update extent. More...
virtual vtkDataSetAttributes * | GetAttributes (int type)
| Returns the attributes of the data object of the specified attribute type. More...
virtual int | GetAttributeTypeForArray (vtkAbstractArray *arr)
| Retrieves the attribute type that an array came from. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this data object. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this data object. More...
virtual vtkTypeBool | GetDataReleased ()
| Get the flag indicating the data has been released. More...
virtual void | SetFieldData (vtkFieldData *)
| Assign or retrieve a general field data to this data object. More...
virtual vtkFieldData * | GetFieldData ()
| Assign or retrieve a general field data to this data object. More...
void | GlobalReleaseDataFlagOn ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
void | GlobalReleaseDataFlagOff ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkPolyData * | New ()
static vtkPolyData * | ExtendedNew ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPolyData * | SafeDownCast (vtkObjectBase *o)
static vtkPolyData * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkPolyData * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkPointSet
static vtkPointSet * | New ()
| Standard instantiation method. More...
static vtkPointSet * | ExtendedNew ()
static vtkPointSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkPointSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkPointSet * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
Static Public Member Functions inherited from vtkDataSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataSet * | SafeDownCast (vtkObjectBase *o)
static vtkDataSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkDataObject
static vtkDataObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataObject * | SafeDownCast (vtkObjectBase *o)
static vtkInformation * | GetActiveFieldInformation (vtkInformation *info, int fieldAssociation, int attributeType)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and attribute (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) More...
static vtkInformation * | GetNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and name. More...
static void | RemoveNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Remove the info associated with an array. More...
static vtkInformation * | SetActiveAttribute (vtkInformation *info, int fieldAssociation, const char *attributeName, int attributeType)
| Set the named array to be the active field for the specified type (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) and association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetActiveAttributeInfo (vtkInformation *info, int fieldAssociation, int attributeType, const char *name, int arrayType, int numComponents, int numTuples)
| Set the name, array type, number of components, and number of tuples within the passed information object for the active attribute of type attributeType (in specified association, FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetPointDataActiveScalarInfo (vtkInformation *info, int arrayType, int numComponents)
| Convenience version of previous method for use (primarily) by the Imaging filters. More...
static const char * | GetAssociationTypeAsString (int associationType)
| Given an integer association type, this static method returns a string type for the attribute (i.e. More...
static int | GetAssociationTypeFromString (const char *associationName)
| Given a string association name, this static method returns an integer association type for the attribute (i.e. More...
static vtkInformationStringKey * | DATA_TYPE_NAME ()
static vtkInformationDataObjectKey * | DATA_OBJECT ()
static vtkInformationIntegerKey * | DATA_EXTENT_TYPE ()
static vtkInformationIntegerPointerKey * | DATA_EXTENT ()
static vtkInformationIntegerVectorKey * | ALL_PIECES_EXTENT ()
static vtkInformationIntegerKey * | DATA_PIECE_NUMBER ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationDoubleKey * | DATA_TIME_STEP ()
static vtkInformationInformationVectorKey * | POINT_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | CELL_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | VERTEX_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | EDGE_DATA_VECTOR ()
static vtkInformationIntegerKey * | FIELD_ARRAY_TYPE ()
static vtkInformationIntegerKey * | FIELD_ASSOCIATION ()
static vtkInformationIntegerKey * | FIELD_ATTRIBUTE_TYPE ()
static vtkInformationIntegerKey * | FIELD_ACTIVE_ATTRIBUTE ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_COMPONENTS ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_TUPLES ()
static vtkInformationIntegerKey * | FIELD_OPERATION ()
static vtkInformationDoubleVectorKey * | FIELD_RANGE ()
static vtkInformationIntegerVectorKey * | PIECE_EXTENT ()
static vtkInformationStringKey * | FIELD_NAME ()
static vtkInformationDoubleVectorKey * | ORIGIN ()
static vtkInformationDoubleVectorKey * | SPACING ()
static vtkInformationDoubleVectorKey * | DIRECTION ()
static vtkInformationDoubleVectorKey * | BOUNDING_BOX ()
static vtkInformationDataObjectKey * | SIL ()
static vtkDataObject * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataObject * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static void | SetGlobalReleaseDataFlag (vtkTypeBool val)
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
static vtkTypeBool | GetGlobalReleaseDataFlag ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Types
using | TaggedCellId = vtkPolyData_detail::TaggedCellId
using | CellMap = vtkPolyData_detail::CellMap

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for type information and printing. More...
| vtkPolyData ()
| ~vtkPolyData () override
void | ReportReferences (vtkGarbageCollector *) override
vtkCellArray * | GetCellArrayInternal (TaggedCellId tag)
Protected Member Functions inherited from vtkPointSet
| vtkPointSet ()
| ~vtkPointSet () override
Protected Member Functions inherited from vtkDataSet
| vtkDataSet ()
| ~vtkDataSet () override
virtual void | ComputeScalarRange ()
| Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime). More...
Protected Member Functions inherited from vtkDataObject
| vtkDataObject ()
| ~vtkDataObject () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkSmartPointer< vtkVertex > | Vertex
vtkSmartPointer< vtkPolyVertex > | PolyVertex
vtkSmartPointer< vtkLine > | Line
vtkSmartPointer< vtkPolyLine > | PolyLine
vtkSmartPointer< vtkTriangle > | Triangle
vtkSmartPointer< vtkQuad > | Quad
vtkSmartPointer< vtkPolygon > | Polygon
vtkSmartPointer< vtkTriangleStrip > | TriangleStrip
vtkSmartPointer< vtkEmptyCell > | EmptyCell
vtkSmartPointer< vtkCellArray > | Verts
vtkSmartPointer< vtkCellArray > | Lines
vtkSmartPointer< vtkCellArray > | Polys
vtkSmartPointer< vtkCellArray > | Strips
vtkSmartPointer< CellMap > | Cells
vtkSmartPointer< vtkCellLinks > | Links
vtkNew< vtkIdList > | LegacyBuffer
double | CellsBounds [6]
vtkTimeStamp | CellsBoundsTime
Protected Attributes inherited from vtkPointSet
bool | Editable
vtkPoints * | Points
vtkAbstractPointLocator * | PointLocator
vtkAbstractCellLocator * | CellLocator
Protected Attributes inherited from vtkDataSet
vtkCellData * | CellData
vtkPointData * | PointData
vtkCallbackCommand * | DataObserver
vtkTimeStamp | ComputeTime
double | Bounds [6]
double | Center [3]
double | ScalarRange [2]
vtkTimeStamp | ScalarRangeComputeTime
vtkUnsignedCharArray * | PointGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
vtkUnsignedCharArray * | CellGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | PointGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | CellGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
Protected Attributes inherited from vtkDataObject
vtkFieldData * | FieldData
vtkTypeBool | DataReleased
vtkTimeStamp | UpdateTime
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static vtkPolyDataDummyContainter | DummyContainer

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

concrete dataset represents vertices, lines, polygons, and triangle strips

vtkPolyData is a data object that is a concrete implementation of vtkDataSet. vtkPolyData represents a geometric structure consisting of vertices, lines, polygons, and/or triangle strips. Point and cell attribute values (e.g., scalars, vectors, etc.) also are represented.

The actual cell types (vtkCellType.h) supported by vtkPolyData are: vtkVertex, vtkPolyVertex, vtkLine, vtkPolyLine, vtkTriangle, vtkQuad, vtkPolygon, and vtkTriangleStrip.

One important feature of vtkPolyData objects is that special traversal and data manipulation methods are available to process data. These methods are generally more efficient than vtkDataSet methods and should be used whenever possible. For example, traversing the cells in a dataset we would use GetCell(). To traverse cells with vtkPolyData we would retrieve the cell array object representing polygons (for example using GetPolys()) and then use vtkCellArray's InitTraversal() and GetNextCell() methods.

Warning
  Because vtkPolyData is implemented with four separate instances of vtkCellArray to represent 0D vertices, 1D lines, 2D polygons, and 2D triangle strips, it is possible to create vtkPolyData instances that consist of a mixture of cell types. Because of the design of the class, there are certain limitations on how mixed cell types are inserted into the vtkPolyData, and in turn the order in which they are processed and rendered. To preserve the consistency of cell ids, and to ensure that cells with cell data are rendered properly, users must insert mixed cells in the order of vertices (vtkVertex and vtkPolyVertex), lines (vtkLine and vtkPolyLine), polygons (vtkTriangle, vtkQuad, vtkPolygon), and triangle strips (vtkTriangleStrip).
  Some filters when processing vtkPolyData with mixed cell types may process the cells in differing ways. Some will convert one type into another (e.g., vtkTriangleStrip into vtkTriangles) or expect a certain type (vtkDecimatePro expects triangles or triangle strips; vtkTubeFilter expects lines). Read the documentation for each filter carefully to understand how each part of vtkPolyData is processed.
  Some of the methods specified here function properly only when the dataset has been specified as "Editable". They are documented as such.

Examples:
  vtkPolyData (Examples)

Online Examples:

Tests:
  vtkPolyData (Tests)

Definition at line 88 of file vtkPolyData.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointSet vtkPolyData::Superclass

Definition at line 94 of file vtkPolyData.h.

## ◆ TaggedCellId

using vtkPolyData::TaggedCellId = vtkPolyData_detail::TaggedCellId
| protected

Definition at line 719 of file vtkPolyData.h.

## ◆ CellMap

using vtkPolyData::CellMap = vtkPolyData_detail::CellMap
| protected

Definition at line 720 of file vtkPolyData.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Scalar field critical point classification (for manifold 2D meshes).

Reference: J. Milnor "Morse Theory", Princeton University Press, 1963.

Given a pointId and an attribute representing a scalar field, this member returns the index of the critical point: vtkPolyData::MINIMUM (index 0): local minimum; vtkPolyData::SADDLE (index 1): local saddle; vtkPolyData::MAXIMUM (index 2): local maximum.

Other returned values are: vtkPolyData::REGULAR_POINT: regular point (the gradient does not vanish); vtkPolyData::ERR_NON_MANIFOLD_STAR: the star of the considered vertex is not manifold (could not evaluate the index) vtkPolyData::ERR_INCORRECT_FIELD: the number of entries in the scalar field array is different form the number of vertices in the mesh. vtkPolyData::ERR_NO_SUCH_FIELD: the specified scalar field does not exist.

Enumerator
ERR_NO_SUCH_FIELD |
ERR_INCORRECT_FIELD |
ERR_NON_MANIFOLD_STAR |
REGULAR_POINT |
MINIMUM |
SADDLE |
MAXIMUM |

Definition at line 673 of file vtkPolyData.h.

## Constructor & Destructor Documentation

## ◆ vtkPolyData()

vtkPolyData::vtkPolyData | ( |  | ) |
| protected

## ◆ ~vtkPolyData()

vtkPolyData::~vtkPolyData | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkPolyData* vtkPolyData::New | ( |  | ) |
| static

## ◆ ExtendedNew()

static vtkPolyData* vtkPolyData::ExtendedNew | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkPolyData::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPolyData::IsA | ( | const char * | type | ) |
| virtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ SafeDownCast()

static vtkPolyData* vtkPolyData::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPolyData::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ NewInstance()

vtkPolyData* vtkPolyData::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPolyData::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ GetDataObjectType()

int vtkPolyData::GetDataObjectType | ( |  | ) |
| inlineoverridevirtual

Return what type of dataset this is.

Reimplemented from vtkPointSet.

Definition at line 100 of file vtkPolyData.h.

## ◆ CopyStructure()

void vtkPolyData::CopyStructure | ( | vtkDataSet * | ds | ) |
| overridevirtual

Copy the geometric and topological structure of an input poly data object.

Reimplemented from vtkPointSet.

## ◆ GetNumberOfCells()

vtkIdType vtkPolyData::GetNumberOfCells | ( |  | ) |
| inlineoverridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkPointSet.

Definition at line 772 of file vtkPolyData.h.

## ◆ GetCell() [1/6]

vtkCell* vtkPolyData::GetCell | ( | vtkIdType | cellId | ) |
| overridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkPointSet.

## ◆ GetCell() [2/6]

void vtkPolyData::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkPointSet.

## ◆ GetCellType()

int vtkPolyData::GetCellType | ( | vtkIdType | cellId | ) |
| inlineoverridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkPointSet.

Definition at line 779 of file vtkPolyData.h.

## ◆ GetCellSize()

vtkIdType vtkPolyData::GetCellSize | ( | vtkIdType | cellId | ) |
| inlineoverridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkPointSet.

Definition at line 789 of file vtkPolyData.h.

## ◆ GetCellBounds()

void vtkPolyData::GetCellBounds | ( | vtkIdType | cellId,
|  | double | bounds[6]
| ) |  |
| overridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkDataSet.

## ◆ GetCellNeighbors()

void vtkPolyData::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds
| ) |  |
| overridevirtual

Standard vtkDataSet interface.

Reimplemented from vtkDataSet.

## ◆ CopyCells()

void vtkPolyData::CopyCells | ( | vtkPolyData * | pd,
|  | vtkIdList * | idList,
|  | vtkIncrementalPointLocator * | locator = `nullptr`
| ) |  |

Copy cells listed in idList from pd, including points, point data, and cell data.

This method assumes that point and cell data have been allocated. If you pass in a point locator, then the points won't be duplicated in the output. This requires the use of an incremental point locator.

## ◆ GetCellPoints() [1/3]

void vtkPolyData::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) |  |
| overridevirtual

Copy a cells point ids into list provided.

(Less efficient.)

Reimplemented from vtkPointSet.

## ◆ GetPointCells() [1/2]

void vtkPolyData::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) |  |
| overridevirtual

Efficient method to obtain cells using a particular point.

Make sure that routine BuildLinks() has been called.

Reimplemented from vtkPointSet.

## ◆ ComputeCellsBounds()

void vtkPolyData::ComputeCellsBounds | ( |  | ) |

Compute the (X, Y, Z) bounds of the data.

Note that the method only considers points that are used by cells. This is done for usability and historical reasons.

IMPORTANT

Until vtk 9.0.1, vtkPolyData::ComputeBounds() used to ignore points that do not belong to any cell. That was not consistent with other vtkPointSet subclasses and thus was error prone. See this ParaView issue https://gitlab.kitware.com/paraview/paraview/-/issues/20354 Now it defers to vtkPointSet::ComputeBounds() so vtkPolyData::GetBounds() may not return the same bounds as before. This behavior is probably the one you want when using bounds.

The previous behavior is still available through vtkPolyData::ComputeCellsBounds() and vtkPolyData::GetCellsBounds(). This is mainly used for rendering purpose.

## ◆ GetCellsBounds()

void vtkPolyData::GetCellsBounds | ( | double | bounds[6] | ) |

Get the cells bounds.

Internally calls ComputeCellsBounds().

See also
  ComputeCellsBounds()

## ◆ Squeeze()

void vtkPolyData::Squeeze | ( |  | ) |
| overridevirtual

Recover extra allocated memory when creating data whose initial size is unknown.

Examples include using the InsertNextCell() method, or when using the CellArray::EstimateSize() method to create vertices, lines, polygons, or triangle strips.

Reimplemented from vtkPointSet.

## ◆ GetMaxCellSize()

int vtkPolyData::GetMaxCellSize | ( |  | ) |
| overridevirtual

Return the maximum cell size in this poly data.

Reimplemented from vtkPointSet.

## ◆ GetCellIdRelativeToCellArray()

vtkIdType vtkPolyData::GetCellIdRelativeToCellArray | ( | vtkIdType | cellId | ) |

Maps the cell at position `cellId` inside the `vtkPolyData` to its location in the corresponding cell array.

For instance, if cell `cellId` is a line, then this method returns the position of this cell in the `Lines` cell array.

## ◆ SetVerts()

void vtkPolyData::SetVerts | ( | vtkCellArray * | v | ) |

Set the cell array defining vertices.

## ◆ GetVerts()

vtkCellArray* vtkPolyData::GetVerts | ( |  | ) |

Get the cell array defining vertices.

If there are no vertices, an empty array will be returned (convenience to simplify traversal).

## ◆ SetLines()

void vtkPolyData::SetLines | ( | vtkCellArray * | l | ) |

Set the cell array defining lines.

## ◆ GetLines()

vtkCellArray* vtkPolyData::GetLines | ( |  | ) |

Get the cell array defining lines.

If there are no lines, an empty array will be returned (convenience to simplify traversal).

## ◆ SetPolys()

void vtkPolyData::SetPolys | ( | vtkCellArray * | p | ) |

Set the cell array defining polygons.

## ◆ GetPolys()

vtkCellArray* vtkPolyData::GetPolys | ( |  | ) |

Get the cell array defining polygons.

If there are no polygons, an empty array will be returned (convenience to simplify traversal).

## ◆ SetStrips()

void vtkPolyData::SetStrips | ( | vtkCellArray * | s | ) |

Set the cell array defining triangle strips.

## ◆ GetStrips()

vtkCellArray* vtkPolyData::GetStrips | ( |  | ) |

Get the cell array defining triangle strips.

If there are no triangle strips, an empty array will be returned (convenience to simplify traversal).

## ◆ GetNumberOfVerts()

vtkIdType vtkPolyData::GetNumberOfVerts | ( |  | ) |
| inline

Return the number of primitives of a particular type held.

Definition at line 237 of file vtkPolyData.h.

## ◆ GetNumberOfLines()

vtkIdType vtkPolyData::GetNumberOfLines | ( |  | ) |
| inline

Return the number of primitives of a particular type held.

Definition at line 238 of file vtkPolyData.h.

## ◆ GetNumberOfPolys()

vtkIdType vtkPolyData::GetNumberOfPolys | ( |  | ) |
| inline

Return the number of primitives of a particular type held.

Definition at line 239 of file vtkPolyData.h.

## ◆ GetNumberOfStrips()

vtkIdType vtkPolyData::GetNumberOfStrips | ( |  | ) |
| inline

Return the number of primitives of a particular type held.

Definition at line 240 of file vtkPolyData.h.

## ◆ AllocateEstimate() [1/2]

bool vtkPolyData::AllocateEstimate | ( | vtkIdType | numCells,
|  | vtkIdType | maxCellSize
| ) |  |

Preallocate memory for the internal cell arrays.

Each of the internal cell arrays (verts, lines, polys, and strips) will be resized to hold numCells cells of size maxCellSize.

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ AllocateEstimate() [2/2]

bool vtkPolyData::AllocateEstimate | ( | vtkIdType | numVerts,
|  | vtkIdType | maxVertSize,
|  | vtkIdType | numLines,
|  | vtkIdType | maxLineSize,
|  | vtkIdType | numPolys,
|  | vtkIdType | maxPolySize,
|  | vtkIdType | numStrips,
|  | vtkIdType | maxStripSize
| ) |  |

Preallocate memory for the internal cell arrays.

Each of the internal cell arrays (verts, lines, polys, and strips) will be resized to hold the indicated number of cells of the specified cell size.

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ AllocateExact() [1/2]

bool vtkPolyData::AllocateExact | ( | vtkIdType | numCells,
|  | vtkIdType | connectivitySize
| ) |  |

Preallocate memory for the internal cell arrays.

Each of the internal cell arrays (verts, lines, polys, and strips) will be resized to hold numCells cells and connectivitySize pointIds.

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ AllocateExact() [2/2]

bool vtkPolyData::AllocateExact | ( | vtkIdType | numVerts,
|  | vtkIdType | vertConnSize,
|  | vtkIdType | numLines,
|  | vtkIdType | lineConnSize,
|  | vtkIdType | numPolys,
|  | vtkIdType | polyConnSize,
|  | vtkIdType | numStrips,
|  | vtkIdType | stripConnSize
| ) |  |

Preallocate memory for the internal cell arrays.

Each of the internal cell arrays (verts, lines, polys, and strips) will be resized to hold the indicated number of cells and the specified number of point ids (ConnSize).

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ AllocateCopy()

bool vtkPolyData::AllocateCopy | ( | vtkPolyData * | pd | ) |

Preallocate memory for the internal cell arrays such that they are the same size as those in pd.

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ AllocateProportional()

bool vtkPolyData::AllocateProportional | ( | vtkPolyData * | pd,
|  | double | ratio
| ) |  |

Preallocate memory for the internal cell arrays such that they are proportional to those in pd by a factor of ratio (for instance, ratio = 2 allocates twice as many cells).

Existing data is not preserved and the number of cells is set to zero.

Returns
  True if allocation succeeds.

## ◆ Allocate() [1/2]

void vtkPolyData::Allocate | ( | vtkIdType | numCells = `1000`,
|  | int | vtkNotUsedextSize = `1000`
| ) |  |
| inline

Method allocates initial storage for vertex, line, polygon, and triangle strip arrays.

Use this method before the method PolyData::InsertNextCell(). (Or, provide vertex, line, polygon, and triangle strip cell arrays). extSize is no longer used.

Definition at line 319 of file vtkPolyData.h.

## ◆ Allocate() [2/2]

void vtkPolyData::Allocate | ( | vtkPolyData * | inPolyData,
|  | vtkIdType | numCells = `1000`,
|  | int | vtkNotUsedextSize = `1000`
| ) |  |
| inline

Similar to the method above, this method allocates initial storage for vertex, line, polygon, and triangle strip arrays.

It does this more intelligently, examining the supplied inPolyData to determine whether to allocate the verts, lines, polys, and strips arrays. (These arrays are allocated only if there is data in the corresponding arrays in the inPolyData.) Caution: if the inPolyData has no verts, and after allocating with this method an PolyData::InsertNextCell() is invoked where a vertex is inserted, bad things will happen.

Definition at line 334 of file vtkPolyData.h.

## ◆ InsertNextCell() [1/2]

vtkIdType vtkPolyData::InsertNextCell | ( | int | type,
|  | int | npts,
|  | const vtkIdType | pts[]
| ) |  |

Insert a cell of type VTK_VERTEX, VTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE, VTK_QUAD, VTK_POLYGON, or VTK_TRIANGLE_STRIP.

Make sure that the PolyData::Allocate() function has been called first or that vertex, line, polygon, and triangle strip arrays have been supplied. Note: will also insert VTK_PIXEL, but converts it to VTK_QUAD.

## ◆ InsertNextCell() [2/2]

vtkIdType vtkPolyData::InsertNextCell | ( | int | type,
|  | vtkIdList * | pts
| ) |  |

Insert a cell of type VTK_VERTEX, VTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE, VTK_QUAD, VTK_POLYGON, or VTK_TRIANGLE_STRIP.

Make sure that the PolyData::Allocate() function has been called first or that vertex, line, polygon, and triangle strip arrays have been supplied. Note: will also insert VTK_PIXEL, but converts it to VTK_QUAD.

## ◆ Reset()

void vtkPolyData::Reset | ( |  | ) |

Begin inserting data all over again.

Memory is not freed but otherwise objects are returned to their initial state.

## ◆ BuildCells()

void vtkPolyData::BuildCells | ( |  | ) |

Create data structure that allows random access of cells.

BuildCells is expensive but necessary to make use of the faster non-virtual implementations of GetCell/GetCellPoints. One may check if cells need to be built via NeedToBuilds before invoking. Cells always need to be built/re-built after low level direct modifications to verts, lines, polys or strips cell arrays.

## ◆ NeedToBuildCells()

bool vtkPolyData::NeedToBuildCells | ( |  | ) |
| inline

Check if BuildCells is needed.

Definition at line 376 of file vtkPolyData.h.

## ◆ BuildLinks()

void vtkPolyData::BuildLinks | ( | int | initialSize = `0` | ) |

Create upward links from points to cells that use each point.

Enables topologically complex queries. Normally the links array is allocated based on the number of points in the vtkPolyData. The optional initialSize parameter can be used to allocate a larger size initially.

## ◆ SetLinks()

virtual void vtkPolyData::SetLinks | ( | vtkAbstractCellLinks * | links | ) |
| virtual

Set/Get the links that you created possibly without using BuildLinks.

Note: Only vtkCellLinks are currently supported.

## ◆ vtkGetSmartPointerMacro()

vtkPolyData::vtkGetSmartPointerMacro | ( | Links | ,
|  | vtkAbstractCellLinks |
| ) |  |

Set/Get the links that you created possibly without using BuildLinks.

Note: Only vtkCellLinks are currently supported.

## ◆ DeleteCells()

void vtkPolyData::DeleteCells | ( |  | ) |

Release data structure that allows random access of the cells.

This must be done before a 2nd call to BuildLinks(). DeleteCells implicitly deletes the links as well since they are no longer valid.

## ◆ DeleteLinks()

void vtkPolyData::DeleteLinks | ( |  | ) |

Release the upward links from point to cells that use each point.

## ◆ GetPointCells() [2/2]

void vtkPolyData::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdType & | ncells,
|  | vtkIdType *& | cells
| ) |  |
| inline

Special (efficient) operations on poly data.

Use carefully (i.e., make sure that BuildLinks() has been called).

Definition at line 765 of file vtkPolyData.h.

## ◆ GetCellEdgeNeighbors()

void vtkPolyData::GetCellEdgeNeighbors | ( | vtkIdType | cellId,
|  | vtkIdType | p1,
|  | vtkIdType | p2,
|  | vtkIdList * | cellIds
| ) |  |

Get the neighbors at an edge.

More efficient than the general GetCellNeighbors(). Assumes links have been built (with BuildLinks()), and looks specifically for edge neighbors.

## ◆ GetCellPoints() [2/3]

unsigned char vtkPolyData::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdType & | npts,
|  | vtkIdType const *& | pts
| ) |  |
| inline

Get a list of point ids that define a cell.

The cell type is returned. Requires the the cells have been built with BuildCells.

Warning
  Subsequent calls to this method may invalidate previous call results.

The pts pointer must not be modified.

Note: This method MAY NOT be thread-safe. (See GetCellAtId at vtkCellArray)

Definition at line 961 of file vtkPolyData.h.

## ◆ GetCellPoints() [3/3]

void vtkPolyData::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdType & | npts,
|  | vtkIdType const *& | pts,
|  | vtkIdList * | ptIds
| ) |  |
| inlineoverridevirtual

Get a list of point ids that define a cell.

Requires the the cells have been built with BuildCells.

This function MAY use ptIds, which is an object that is created by each thread, to guarantee thread safety.

Warning
  Subsequent calls to this method may invalidate previous call results.

The pts pointer must not be modified.

Note: This method is thread-safe.

Reimplemented from vtkDataSet.

Definition at line 983 of file vtkPolyData.h.

## ◆ IsTriangle()

int vtkPolyData::IsTriangle | ( | int | v1,
|  | int | v2,
|  | int | v3
| ) |  |
| inline

Given three vertices, determine whether it's a triangle.

Make sure BuildLinks() has been called first.

Definition at line 822 of file vtkPolyData.h.

## ◆ IsEdge()

int vtkPolyData::IsEdge | ( | vtkIdType | p1,
|  | vtkIdType | p2
| ) |  |

Determine whether two points form an edge.

If they do, return non-zero. By definition PolyVertex and PolyLine have no edges since 1-dimensional edges are only found on cells 2D and higher. Edges are defined as 1-D boundary entities to cells. Make sure BuildLinks() has been called first.

## ◆ IsPointUsedByCell()

int vtkPolyData::IsPointUsedByCell | ( | vtkIdType | ptId,
|  | vtkIdType | cellId
| ) |  |
| inline

Determine whether a point is used by a particular cell.

If it is, return non-zero. Make sure BuildCells() has been called first.

Definition at line 852 of file vtkPolyData.h.

## ◆ ReplaceCell() [1/2]

void vtkPolyData::ReplaceCell | ( | vtkIdType | cellId,
|  | vtkIdList * | ids
| ) |  |

Replace the points defining cell "cellId" with a new set of points.

This operator is (typically) used when links from points to cells have not been built (i.e., BuildLinks() has not been executed). Use the operator ReplaceLinkedCell() to replace a cell when cell structure has been built. Use this method only when the dataset is set as Editable.

## ◆ ReplaceCell() [2/2]

void vtkPolyData::ReplaceCell | ( | vtkIdType | cellId,
|  | int | npts,
|  | const vtkIdType | pts[]
| ) |  |

Replace the points defining cell "cellId" with a new set of points.

This operator is (typically) used when links from points to cells have not been built (i.e., BuildLinks() has not been executed). Use the operator ReplaceLinkedCell() to replace a cell when cell structure has been built. Use this method only when the dataset is set as Editable.

## ◆ ReplaceCellPoint() [1/2]

void vtkPolyData::ReplaceCellPoint | ( | vtkIdType | cellId,
|  | vtkIdType | oldPtId,
|  | vtkIdType | newPtId
| ) |  |
| inline

Replace a point in the cell connectivity list with a different point.

Use this method only when the dataset is set as Editable.

The version with cellPointIds avoids allocating/deallocating a vtkIdList at each call internally.

THIS METHOD IS THREAD SAFE IF BuildCells() IS FIRST CALLED FROM A SINGLE THREAD.

Definition at line 931 of file vtkPolyData.h.

## ◆ ReplaceCellPoint() [2/2]

void vtkPolyData::ReplaceCellPoint | ( | vtkIdType | cellId,
|  | vtkIdType | oldPtId,
|  | vtkIdType | newPtId,
|  | vtkIdList * | cellPointIds
| ) |  |
| inline

Replace a point in the cell connectivity list with a different point.

Use this method only when the dataset is set as Editable.

The version with cellPointIds avoids allocating/deallocating a vtkIdList at each call internally.

THIS METHOD IS THREAD SAFE IF BuildCells() IS FIRST CALLED FROM A SINGLE THREAD.

Definition at line 938 of file vtkPolyData.h.

## ◆ ReverseCell()

void vtkPolyData::ReverseCell | ( | vtkIdType | cellId | ) |

Reverse the order of point ids defining the cell.

Use this method only when the dataset is set as Editable.

## ◆ DeletePoint()

void vtkPolyData::DeletePoint | ( | vtkIdType | ptId | ) |
| inline

Mark a point/cell as deleted from this vtkPolyData.

Use this method only when the dataset is set as Editable.

Definition at line 870 of file vtkPolyData.h.

## ◆ DeleteCell()

void vtkPolyData::DeleteCell | ( | vtkIdType | cellId | ) |
| inline

Mark a point/cell as deleted from this vtkPolyData.

Use this method only when the dataset is set as Editable.

Definition at line 876 of file vtkPolyData.h.

## ◆ RemoveDeletedCells()

void vtkPolyData::RemoveDeletedCells | ( |  | ) |

The cells marked by calls to DeleteCell are stored in the Cell Array VTK_EMPTY_CELL, but they still exist in the cell arrays.

Calling RemoveDeletedCells will traverse the cell arrays and remove/compact the cell arrays as well as any cell data thus truly removing the cells from the polydata object. Use this method only when the dataset is set as Editable.

## ◆ InsertNextLinkedPoint() [1/2]

vtkIdType vtkPolyData::InsertNextLinkedPoint | ( | int | numLinks | ) |

Add a point to the cell data structure (after cell pointers have been built).

This method adds the point and then allocates memory for the links to the cells. (To use this method, make sure points are available and BuildLinks() has been invoked.) Of the two methods below, one inserts a point coordinate and the other just makes room for cell links. Use this method only when the dataset is set as Editable.

## ◆ InsertNextLinkedPoint() [2/2]

vtkIdType vtkPolyData::InsertNextLinkedPoint | ( | double | x[3],
|  | int | numLinks
| ) |  |

Add a point to the cell data structure (after cell pointers have been built).

This method adds the point and then allocates memory for the links to the cells. (To use this method, make sure points are available and BuildLinks() has been invoked.) Of the two methods below, one inserts a point coordinate and the other just makes room for cell links. Use this method only when the dataset is set as Editable.

## ◆ InsertNextLinkedCell()

vtkIdType vtkPolyData::InsertNextLinkedCell | ( | int | type,
|  | int | npts,
|  | const vtkIdType | pts[]
| ) |  |

Add a new cell to the cell data structure (after cell pointers have been built).

This method adds the cell and then updates the links from the points to the cells. (Memory is allocated as necessary.) Use this method only when the dataset is set as Editable.

## ◆ ReplaceLinkedCell()

void vtkPolyData::ReplaceLinkedCell | ( | vtkIdType | cellId,
|  | int | npts,
|  | const vtkIdType | pts[]
| ) |  |

Replace one cell with another in cell structure.

This operator updates the connectivity list and the point's link list. It does not delete references to the old cell in the point's link list. Use the operator RemoveCellReference() to delete all references from points to (old) cell. You may also want to consider using the operator ResizeCellList() if the link list is changing size. Use this method only when the dataset is set as Editable.

## ◆ RemoveCellReference()

void vtkPolyData::RemoveCellReference | ( | vtkIdType | cellId | ) |
| inline

Remove all references to cell in cell structure.

This means the links from the cell's points to the cell are deleted. Memory is not reclaimed. Use the method ResizeCellList() to resize the link list from a point to its using cells. (This operator assumes BuildLinks() has been called.) Use this method only when the dataset is set as Editable.

Definition at line 882 of file vtkPolyData.h.

## ◆ AddCellReference()

void vtkPolyData::AddCellReference | ( | vtkIdType | cellId | ) |
| inline

Add references to cell in cell structure.

This means the links from the cell's points to the cell are modified. Memory is not extended. Use the method ResizeCellList() to resize the link list from a point to its using cells. (This operator assumes BuildLinks() has been called.) Use this method only when the dataset is set as Editable.

Definition at line 895 of file vtkPolyData.h.

## ◆ RemoveReferenceToCell()

void vtkPolyData::RemoveReferenceToCell | ( | vtkIdType | ptId,
|  | vtkIdType | cellId
| ) |  |

Remove a reference to a cell in a particular point's link list.

You may also consider using RemoveCellReference() to remove the references from all the cell's points to the cell. This operator does not reallocate memory; use the operator ResizeCellList() to do this if necessary. Use this method only when the dataset is set as Editable.

## ◆ AddReferenceToCell()

void vtkPolyData::AddReferenceToCell | ( | vtkIdType | ptId,
|  | vtkIdType | cellId
| ) |  |

Add a reference to a cell in a particular point's link list.

(You may also consider using AddCellReference() to add the references from all the cell's points to the cell.) This operator does not realloc memory; use the operator ResizeCellList() to do this if necessary. Use this method only when the dataset is set as Editable.

## ◆ ResizeCellList()

void vtkPolyData::ResizeCellList | ( | vtkIdType | ptId,
|  | int | size
| ) |  |
| inline

Resize the list of cells using a particular point.

(This operator assumes that BuildLinks() has been called.) Use this method only when the dataset is set as Editable.

Definition at line 908 of file vtkPolyData.h.

## ◆ Initialize()

void vtkPolyData::Initialize | ( |  | ) |
| overridevirtual

Restore object to initial state.

Release memory back to system.

Reimplemented from vtkPointSet.

## ◆ GetPiece()

virtual int vtkPolyData::GetPiece | ( |  | ) |
| virtual

Get the piece and the number of pieces.

Similar to extent in 3D.

## ◆ GetNumberOfPieces()

virtual int vtkPolyData::GetNumberOfPieces | ( |  | ) |
| virtual

Get the piece and the number of pieces.

Similar to extent in 3D.

## ◆ GetGhostLevel()

virtual int vtkPolyData::GetGhostLevel | ( |  | ) |
| virtual

Get the ghost level.

## ◆ GetActualMemorySize()

unsigned long vtkPolyData::GetActualMemorySize | ( |  | ) |
| overridevirtual

Return the actual size of the data in kibibytes (1024 bytes).

This number is valid only after the pipeline has updated. The memory size returned is guaranteed to be greater than or equal to the memory required to represent the data (e.g., extra space in arrays, etc. are not included in the return value). THIS METHOD IS THREAD SAFE.

Reimplemented from vtkPointSet.

## ◆ ShallowCopy()

void vtkPolyData::ShallowCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkPointSet.

## ◆ DeepCopy()

void vtkPolyData::DeepCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkPointSet.

## ◆ RemoveGhostCells()

void vtkPolyData::RemoveGhostCells | ( |  | ) |

This method will remove any cell that is marked as ghost (has the vtkDataSetAttributes::DUPLICATECELL or the vtkDataSetAttributes::HIDDENCELL bit set).

It does not remove unused points.

## ◆ GetData() [1/2]

static vtkPolyData* vtkPolyData::GetData | ( | vtkInformation * | info | ) |
| static

Retrieve an instance of this class from an information object.

## ◆ GetData() [2/2]

static vtkPolyData* vtkPolyData::GetData | ( | vtkInformationVector * | v,
|  | int | i = `0`
| ) |  |
| static

Retrieve an instance of this class from an information object.

## ◆ GetScalarFieldCriticalIndex() [1/3]

int vtkPolyData::GetScalarFieldCriticalIndex | ( | vtkIdType | pointId,
|  | vtkDataArray * | scalarField
| ) |  |

## ◆ GetScalarFieldCriticalIndex() [2/3]

int vtkPolyData::GetScalarFieldCriticalIndex | ( | vtkIdType | pointId,
|  | int | fieldId
| ) |  |

## ◆ GetScalarFieldCriticalIndex() [3/3]

int vtkPolyData::GetScalarFieldCriticalIndex | ( | vtkIdType | pointId,
|  | const char * | fieldName
| ) |  |

## ◆ GetMeshMTime()

virtual vtkMTimeType vtkPolyData::GetMeshMTime | ( |  | ) |
| virtual

Return the mesh (geometry/topology) modification time.

This time is different from the usual MTime which also takes into account the modification of data arrays. This function can be used to track the changes on the mesh separately from the data arrays (eg. static mesh over time with transient data).

## ◆ GetMTime()

vtkMTimeType vtkPolyData::GetMTime | ( |  | ) |
| overridevirtual

Get MTime which also considers its cell array MTime.

Reimplemented from vtkPointSet.

## ◆ GetCell() [3/6]

unsigned char vtkPolyData::GetCell | ( | vtkIdType | cellId,
|  | const vtkIdType *& | pts
| ) |  |

Get a pointer to the cell, ie [npts pid1 .

. pidn]. The cell type is returned. Requires the the cells have been built with BuildCells. The pts pointer must not be modified.

Warning
  Internal cell storage has changed, and cell size is no longer stored with the cell point ids. The `pts` array returned here no longer exists in memory.

## ◆ ReportReferences()

void vtkPolyData::ReportReferences | ( | vtkGarbageCollector * |  | ) |
| overrideprotectedvirtual

Reimplemented from vtkPointSet.

## ◆ GetCellArrayInternal()

vtkCellArray * vtkPolyData::GetCellArrayInternal | ( | vtkPolyData::TaggedCellId | tag | ) |
| inlineprotected

Definition at line 914 of file vtkPolyData.h.

## ◆ GetCell() [4/6]

virtual vtkCell* vtkDataSet::GetCell

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

The returned vtkCell is an object owned by this instance, hence the return value must not be deleted by the caller.

Warning
  Repeat calls to this function for different face ids will change the data stored in the internal member object whose pointer is returned by this function.
  THIS METHOD IS NOT THREAD SAFE. For a thread-safe version, please use void GetCell(vtkIdType cellId, vtkGenericCell* cell).

## ◆ GetCell() [5/6]

virtual vtkCell* vtkDataSet::GetCell
| inline

Standard vtkDataSet interface.

Definition at line 127 of file vtkDataSet.h.

## ◆ GetCell() [6/6]

virtual void vtkDataSet::GetCell

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

This is a thread-safe alternative to the previous GetCell() method. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## Member Data Documentation

## ◆ Vertex

vtkSmartPointer<vtkVertex> vtkPolyData::Vertex
| protected

Definition at line 725 of file vtkPolyData.h.

## ◆ PolyVertex

vtkSmartPointer<vtkPolyVertex> vtkPolyData::PolyVertex
| protected

Definition at line 726 of file vtkPolyData.h.

## ◆ Line

vtkSmartPointer<vtkLine> vtkPolyData::Line
| protected

Definition at line 727 of file vtkPolyData.h.

## ◆ PolyLine

vtkSmartPointer<vtkPolyLine> vtkPolyData::PolyLine
| protected

Definition at line 728 of file vtkPolyData.h.

## ◆ Triangle

vtkSmartPointer<vtkTriangle> vtkPolyData::Triangle
| protected

Definition at line 729 of file vtkPolyData.h.

## ◆ Quad

vtkSmartPointer<vtkQuad> vtkPolyData::Quad
| protected

Definition at line 730 of file vtkPolyData.h.

## ◆ Polygon

vtkSmartPointer<vtkPolygon> vtkPolyData::Polygon
| protected

Definition at line 731 of file vtkPolyData.h.

## ◆ TriangleStrip

vtkSmartPointer<vtkTriangleStrip> vtkPolyData::TriangleStrip
| protected

Definition at line 732 of file vtkPolyData.h.

## ◆ EmptyCell

vtkSmartPointer<vtkEmptyCell> vtkPolyData::EmptyCell
| protected

Definition at line 733 of file vtkPolyData.h.

## ◆ Verts

vtkSmartPointer<vtkCellArray> vtkPolyData::Verts
| protected

Definition at line 737 of file vtkPolyData.h.

## ◆ Lines

vtkSmartPointer<vtkCellArray> vtkPolyData::Lines
| protected

Definition at line 738 of file vtkPolyData.h.

## ◆ Polys

vtkSmartPointer<vtkCellArray> vtkPolyData::Polys
| protected

Definition at line 739 of file vtkPolyData.h.

## ◆ Strips

vtkSmartPointer<vtkCellArray> vtkPolyData::Strips
| protected

Definition at line 740 of file vtkPolyData.h.

## ◆ Cells

vtkSmartPointer<CellMap> vtkPolyData::Cells
| protected

Definition at line 744 of file vtkPolyData.h.

## ◆ Links

vtkSmartPointer<vtkCellLinks> vtkPolyData::Links
| protected

Definition at line 745 of file vtkPolyData.h.

## ◆ LegacyBuffer

vtkNew<vtkIdList> vtkPolyData::LegacyBuffer
| protected

Definition at line 747 of file vtkPolyData.h.

## ◆ DummyContainer

vtkPolyDataDummyContainter vtkPolyData::DummyContainer
| staticprotected

Definition at line 750 of file vtkPolyData.h.

## ◆ CellsBounds

double vtkPolyData::CellsBounds[6]
| protected

Definition at line 753 of file vtkPolyData.h.

## ◆ CellsBoundsTime

vtkTimeStamp vtkPolyData::CellsBoundsTime
| protected

Definition at line 755 of file vtkPolyData.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkPolyData.h